Imports CrystalDecisions.CrystalReports.Engine
Imports CrystalDecisions.Shared

Public Class WebForm1
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents crvPrueba As CrystalDecisions.Web.CrystalReportViewer
    Protected WithEvents btnExportar As System.Web.UI.WebControls.Button
    Protected WithEvents ddlTipos As System.Web.UI.WebControls.DropDownList
    Protected WithEvents Form1 As System.Web.UI.HtmlControls.HtmlForm

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Dim crDatos As New crPrueba
    Private nombreReporte As String = "Reporte"

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim ds As New DsPruebas

        'Es importante utilizar el System.Data.MissingSchemaAction.Ignore, 
        'para que nos evite errores y haga el merge correctamente
        ds.Merge(ReturnDataSet, False, System.Data.MissingSchemaAction.Ignore)

        crDatos.SetDataSource(ds)
        Me.crvPrueba.ReportSource = crDatos
    End Sub

    'Este ReturnDataSet es solo a modo de ejemplo, 
    'lo ideal es que el dataset sea el producto de alguna consulta a la base de datos,
    'solo que para efectos del ejemplo creamos el dataset manualmente.
    Private Function ReturnDataSet() As DataSet
        Dim dt As New DataTable
        Dim dr As DataRow
        Dim ds As New DataSet

        dt.Columns.Add(New DataColumn("CodigoEjecutivo", GetType(Integer)))
        dt.Columns.Add(New DataColumn("NombreEjecutivo", GetType(String)))

        dr = dt.NewRow()
        dr("CodigoEjecutivo") = 1
        dr("NombreEjecutivo") = "Carlos Solano"
        dt.Rows.Add(dr)

        dr = dt.NewRow()
        dr("CodigoEjecutivo") = 2
        dr("NombreEjecutivo") = "Marta Campos"
        dt.Rows.Add(dr)

        dr = dt.NewRow()
        dr("CodigoEjecutivo") = 3
        dr("NombreEjecutivo") = "Marco Campos"
        dt.Rows.Add(dr)

        dr = dt.NewRow()
        dr("CodigoEjecutivo") = 4
        dr("NombreEjecutivo") = "Luis Ramirez"
        dt.Rows.Add(dr)

        dr = dt.NewRow()
        dr("CodigoEjecutivo") = 5
        dr("NombreEjecutivo") = "Roger Alvarado"
        dt.Rows.Add(dr)

        dr = dt.NewRow()
        dr("CodigoEjecutivo") = 6
        dr("NombreEjecutivo") = "Miguel Rios"
        dt.Rows.Add(dr)

        dr = dt.NewRow()
        dr("CodigoEjecutivo") = 7
        dr("NombreEjecutivo") = "Martha Fonseca"
        dt.Rows.Add(dr)

        ds.Tables.Add(dt)
        ds.Tables(0).TableName = "Ejecutivos"

        Return ds

    End Function

    Private Sub btnExportar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExportar.Click
        'Se crea el documento de lectura y escritura
        Dim rptStream As New System.IO.MemoryStream
        'se envia el reporte el stram y le indicamos el metodo de escritura o tipo de documento
        rptStream = CType(crDatos.ExportToStream(CInt(ddlTipos.SelectedValue)), System.IO.MemoryStream)

        'Limpiamos la memoria
        Response.Clear()
        Response.Buffer = True

        'Le indicamos el tipo de documento que vamos a exportar
        Response.ContentType = FormatoDocumento()

        'Automaticamente se descarga el archivo
        Response.AddHeader("Content-Disposition", "attachment;filename=" + Me.nombreReporte)

        'Se escribe el archivo
        Response.BinaryWrite(rptStream.ToArray())
        Response.End()
    End Sub

    'Indicamos el Tipo de archivo que vamos a exportar,
    'tambien le indicamos la extension
    Private Function FormatoDocumento() As String
        Dim tipo As String
        Select Case Integer.Parse(ddlTipos.SelectedValue)
            Case ExportFormatType.Excel
                tipo = "application/vnd.ms-excel"
                nombreReporte &= ".xls"
            Case ExportFormatType.RichText
                tipo = "application/rtf"
                nombreReporte &= ".rtf"
            Case ExportFormatType.WordForWindows
                tipo = "application/msword"
                nombreReporte &= ".doc"
            Case Else
                tipo = "application/pdf"
                nombreReporte &= ".pdf"
        End Select
        Return tipo
    End Function

End Class
